var app = angular.module('TaskerHelp', []);

// app.config(function ($locationProvider) {
//     $locationProvider.html5Mode(true)
//         .hashPrefix('#');
// });

app.controller('HelpController', function ($scope, $location, $q, $http, $templateCache) {
    var _this = this;
    _this.order = 'Title';
    _this.search = {};
    _this.search.Category = $location.search()['category'];



    // watch for changes to our $location.url() object.
    $scope.$watch(function () {
        return $location.url();
    }, function (url) {
        if (url) {
            var locationSearch = $location.search();
            var blockId = locationSearch.blockId;
            if (blockId) {
                scrollTo('#' + blockId);
            }
        }
    });



    _this.setOrder = function (order) {
        _this.order = order;
    };

    _this.getHtml = function (block) {
        return block.Id + '.html';
    };

    _this.scrollTo = function (block) {
        $location.search('blockId', block.Id);
        // scrollTo('#' + block.Id);
    };

    _this.Blocks = [
        {
            Id: "other-comment", Title: "Other - Comment", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Description", Type: "Text" },
            ]
        },
        {
            Id: "other-commandline", Title: "Other - Command Line", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Command", Type: "Text" },
            ]
        },
        {
            Id: "other-reboot", Title: "Other - Reboot", Category: "Task Actions", Since: "3.0", Arguments: [
            ]
        },
        {
            Id: "other-executetask", Title: "Other - Execute Task", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Task", Type: "Text" },
            ]
        },
        {
            Id: "relayoutputs-closerelay", Title: "Relay Outputs - Close Relay", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
            ]
        },
        {
            Id: "relayoutputs-openrelay", Title: "Relay Outputs - Open Relay", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
            ]
        },
        {
            Id: "relayoutputs-setrelay", Title: "Relay Outputs - Set Relay State", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
                { Name: "State", Type: "HIGH or LOW" },
            ]
        },
        {
            Id: "relayoutputs-pulserelay", Title: "Relay Outputs - Pulse Relay", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
                { Name: "Duration", Type: "Seconds, can use decimals" }
            ]
        },
        {
            Id: "relayoutputs-setrelays", Title: "Relay Outputs - Set Relay States", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Channels", Type: "Number Block" },
                { Name: "States", Type: "Number Block" },
            ]
        },
        {
            Id: "relayoutputs-pulserelays", Title: "Relay Outputs - Pulse Relay States", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
                { Name: "States", Type: "Number Block" },
                { Name: "Duration", Type: "Seconds, can use decimals" }
            ]
        },
        {
            Id: "timing-sleep", Title: "Timing - Sleep", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Duration", Type: "Number Block" },
            ]
        },
        {
            Id: "controlstructures-loop", Title: "Control Structures - Loop", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Loop Variable", Type: "Text" },
                { Name: "Start Value of Length", Type: "Number Block" },
                { Name: "End Value of Length", Type: "Number Block" },
            ]
        },
        {
            Id: "controlstructures-ifblock", Title: "Control Structures - If Block", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "If Variable", Type: "Text" },
            ]
        },
        {
            Id: "controlpanel-setled", Title: "Control Panel - Set LED", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
                { Name: "LED State", Type: "Drop-Down option" },
            ]
        },
        {
            Id: "controlpanel-playalarm", Title: "Control Panel - Play Alarm", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Alarm Rate", Type: "Drop-Down option" },
                { Name: "Duration", Type: "Number Block" },
                { Name: "Volume Percentage", Type: "Number Block" },
            ]
        },
        {
            Id: "controlpanel-silencealarm", Title: "Control Panel - Silence Alarm", Category: "Task Actions", Since: "3.0", Arguments: [
            ]
        },
        {
            Id: "logging-logentry", Title: "Logging - Log Entry", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Text to be Logged", Type: "Text" },
                { Name: "File Path", Type: "Text" },
            ]
        },
        {
            Id: "logging-logprofile", Title: "Logging - Log Profile", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Log Profile being called", Type: "Text" },
            ]
        },
        {
            Id: "network-tcpsend", Title: "Network - Tcp Send", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Device", Type: "Drop-Down Select" },
                { Name: "Info being sent", Type: "Text" },
            ]
        },
        {
            Id: "network-emailsend", Title: "Network - Email Send", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Recipient Email", Type: "Text" },
                { Name: "Email's Subject", Type: "Text" },
                { Name: "Email's Message", Type: "Text" },
            ]
        },
        {
            Id: "network-emailprofilesend", Title: "Network - Email Profile Send", Category: "Task Actions", Since: "3.0", Arguments: [
                { Name: "Email Profile", Type: "Text" },
            ]
        },


        // { Id: "file-delete", Title: "File - Delete", Category: "Menu", Since: "1.0" },
        // { Id: "file-download", Title: "File - Download", Category: "Menu", Since: "1.0" },
        // { Id: "file-new", Title: "File - New", Category: "Menu", Since: "1.0" },
        // { Id: "file-open", Title: "File - Open", Category: "Menu", Since: "1.0" },
        // { Id: "file-samples", Title: "File - Samples", Category: "Menu", Since: "1.0" },
        // { Id: "file-save", Title: "File - Save", Category: "Menu", Since: "1.0" },
        // { Id: "file-revert", Title: "File - Revert", Category: "Menu", Since: "1.0" },
        // { Id: "file-saveas", Title: "File - Save As", Category: "Menu", Since: "1.0" },
        // { Id: "file-upload", Title: "File - Upload", Category: "Menu", Since: "1.0" },

    ];



    _this.getCategories = function () {
        return ['Task Actions'];
    };



    // var promises = [];
    // _this.Blocks.forEach(function (element) {
    //     var promise = $http.get(element.Id + '.html', { cache: $templateCache })
    //         .then(function () {
    //             console.log(element.Id + '.html loaded');
    //         });
    //     promises.push(promise);
    // });
    // Promise.all(promises).then(function (data) {
    //     console.log('All templates are loaded into the cache !');

    //     if ($location.hash()) {
    //         setTimeout(function () {
    //             var locationSearch = $location.search();
    //             var blockId = locationSearch.blockId;
    //             if (blockId) {
    //                 scrollTo('#' + blockId);
    //             }
    //         }, 100);
    //     }
    // });


});


